﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows;


namespace Grid_no_repetitions
{
    public class CustomMultiConverter : IMultiValueConverter
    {
        #region IMultiValueConverter Members

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((values[0] != null && values[1] != null) &&
                (values[0] != DependencyProperty.UnsetValue && values[1] != DependencyProperty.UnsetValue) &&
                (values[0].GetType() == typeof(CellValuePresenter) && values[1].GetType() == typeof(Field)))
            {
                CellValuePresenter cvp = values[0] as CellValuePresenter;
                Field field = values[1] as Field;

                if (field.Name == "Name")
                {
                    if ((cvp.Record as DataRecord).VisibleIndex > 0)
                    {
                        GridViewPanelFlat flat = Utilities.GetAncestorFromType(cvp, typeof(GridViewPanelFlat), false) as GridViewPanelFlat;
                        if (flat != null)
                        {
                            DataRecordPresenter upperRecord = flat.ContainerFromIndex((cvp.Record as DataRecord).VisibleIndex - 1) as DataRecordPresenter;
                            if (upperRecord != null && !upperRecord.IsAddRecord && upperRecord.Record.GetType() != typeof(FilterRecord) && cvp.Value.ToString() == (upperRecord.Record as DataRecord).Cells[field].Value.ToString())
                            {
                                return Brushes.Transparent;
                            }
                            else
                            {
                                return Brushes.Black;
                            }
                        }
                    }
                }
                if (field.Name == "Age")
                {
                    CellValuePresenter frontCvp = CellValuePresenter.FromCell(cvp.Record.Cells["Name"]);

                    if (frontCvp != null && frontCvp.Foreground == Brushes.Transparent)
                    {
                        if ((cvp.Record as DataRecord).VisibleIndex > 0)
                        {
                            GridViewPanelFlat flat = Utilities.GetAncestorFromType(cvp, typeof(GridViewPanelFlat), false) as GridViewPanelFlat;
                            if (flat != null)
                            {
                                DataRecordPresenter upperRecord = flat.ContainerFromIndex((cvp.Record as DataRecord).VisibleIndex - 1) as DataRecordPresenter;
                                if (upperRecord != null && !upperRecord.IsAddRecord && upperRecord.Record.GetType() != typeof(FilterRecord) && cvp.Value.ToString() == (upperRecord.Record as DataRecord).Cells[field].Value.ToString())
                                {
                                    return Brushes.Transparent;
                                }
                                else
                                {
                                    return Brushes.Black;
                                }
                            }
                        }
                    }
                    else
                    {
                        return Brushes.Black;
                    }
                }
            }
            
            return Binding.DoNothing;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            return new object[] { };
        }

        #endregion
    }
}
